// Code generated by private/model/cli/gen-api/main.go. DO NOT EDIT.

package apigatewayv2

import (
	"github.com/aws/aws-sdk-go-v2/aws"
	"github.com/aws/aws-sdk-go-v2/aws/signer/v4"
	"github.com/aws/aws-sdk-go-v2/private/protocol/restjson"
)

// ApiGatewayV2 provides the API operation methods for making requests to
// AmazonApiGatewayV2. See this package's package overview docs
// for details on the service.
//
// ApiGatewayV2 methods are safe to use concurrently. It is not safe to
// modify mutate any of the struct's properties though.
type ApiGatewayV2 struct {
	*aws.Client
}

// Used for custom client initialization logic
var initClient func(*ApiGatewayV2)

// Used for custom request initialization logic
var initRequest func(*ApiGatewayV2, *aws.Request)

// Service information constants
const (
	ServiceName = "apigateway" // Service endpoint prefix API calls made to.
	EndpointsID = ServiceName  // Service ID for Regions and Endpoints metadata.
)

// New creates a new instance of the ApiGatewayV2 client with a config.
//
// Example:
//     // Create a ApiGatewayV2 client from just a config.
//     svc := apigatewayv2.New(myConfig)
func New(config aws.Config) *ApiGatewayV2 {
	var signingName string
	signingName = "apigateway"
	signingRegion := config.Region

	svc := &ApiGatewayV2{
		Client: aws.NewClient(
			config,
			aws.Metadata{
				ServiceName:   ServiceName,
				SigningName:   signingName,
				SigningRegion: signingRegion,
				APIVersion:    "2018-11-29",
				JSONVersion:   "1.1",
			},
		),
	}

	// Handlers
	svc.Handlers.Sign.PushBackNamed(v4.SignRequestHandler)
	svc.Handlers.Build.PushBackNamed(restjson.BuildHandler)
	svc.Handlers.Unmarshal.PushBackNamed(restjson.UnmarshalHandler)
	svc.Handlers.UnmarshalMeta.PushBackNamed(restjson.UnmarshalMetaHandler)
	svc.Handlers.UnmarshalError.PushBackNamed(restjson.UnmarshalErrorHandler)

	// Run custom client initialization if present
	if initClient != nil {
		initClient(svc)
	}

	return svc
}

// newRequest creates a new request for a ApiGatewayV2 operation and runs any
// custom request initialization.
func (c *ApiGatewayV2) newRequest(op *aws.Operation, params, data interface{}) *aws.Request {
	req := c.NewRequest(op, params, data)

	// Run custom request initialization if present
	if initRequest != nil {
		initRequest(c, req)
	}

	return req
}
