// Code generated by private/model/cli/gen-api/main.go. DO NOT EDIT.

package autoscalingplans

import (
	"github.com/aws/aws-sdk-go-v2/aws"
	"github.com/aws/aws-sdk-go-v2/aws/signer/v4"
	"github.com/aws/aws-sdk-go-v2/private/protocol/jsonrpc"
)

// AutoScalingPlans provides the API operation methods for making requests to
// AWS Auto Scaling Plans. See this package's package overview docs
// for details on the service.
//
// AutoScalingPlans methods are safe to use concurrently. It is not safe to
// modify mutate any of the struct's properties though.
type AutoScalingPlans struct {
	*aws.Client
}

// Used for custom client initialization logic
var initClient func(*AutoScalingPlans)

// Used for custom request initialization logic
var initRequest func(*AutoScalingPlans, *aws.Request)

// Service information constants
const (
	ServiceName = "autoscaling" // Service endpoint prefix API calls made to.
	EndpointsID = ServiceName   // Service ID for Regions and Endpoints metadata.
)

// New creates a new instance of the AutoScalingPlans client with a config.
//
// Example:
//     // Create a AutoScalingPlans client from just a config.
//     svc := autoscalingplans.New(myConfig)
func New(config aws.Config) *AutoScalingPlans {
	var signingName string
	signingName = "autoscaling-plans"
	signingRegion := config.Region

	svc := &AutoScalingPlans{
		Client: aws.NewClient(
			config,
			aws.Metadata{
				ServiceName:   ServiceName,
				SigningName:   signingName,
				SigningRegion: signingRegion,
				APIVersion:    "2018-01-06",
				JSONVersion:   "1.1",
				TargetPrefix:  "AnyScaleScalingPlannerFrontendService",
			},
		),
	}

	// Handlers
	svc.Handlers.Sign.PushBackNamed(v4.SignRequestHandler)
	svc.Handlers.Build.PushBackNamed(jsonrpc.BuildHandler)
	svc.Handlers.Unmarshal.PushBackNamed(jsonrpc.UnmarshalHandler)
	svc.Handlers.UnmarshalMeta.PushBackNamed(jsonrpc.UnmarshalMetaHandler)
	svc.Handlers.UnmarshalError.PushBackNamed(jsonrpc.UnmarshalErrorHandler)

	// Run custom client initialization if present
	if initClient != nil {
		initClient(svc)
	}

	return svc
}

// newRequest creates a new request for a AutoScalingPlans operation and runs any
// custom request initialization.
func (c *AutoScalingPlans) newRequest(op *aws.Operation, params, data interface{}) *aws.Request {
	req := c.NewRequest(op, params, data)

	// Run custom request initialization if present
	if initRequest != nil {
		initRequest(c, req)
	}

	return req
}
