// Code generated by private/model/cli/gen-api/main.go. DO NOT EDIT.

package cloudtrail

import (
	"github.com/aws/aws-sdk-go-v2/aws"
	"github.com/aws/aws-sdk-go-v2/aws/signer/v4"
	"github.com/aws/aws-sdk-go-v2/private/protocol/jsonrpc"
)

// CloudTrail provides the API operation methods for making requests to
// AWS CloudTrail. See this package's package overview docs
// for details on the service.
//
// CloudTrail methods are safe to use concurrently. It is not safe to
// modify mutate any of the struct's properties though.
type CloudTrail struct {
	*aws.Client
}

// Used for custom client initialization logic
var initClient func(*CloudTrail)

// Used for custom request initialization logic
var initRequest func(*CloudTrail, *aws.Request)

// Service information constants
const (
	ServiceName = "cloudtrail" // Service endpoint prefix API calls made to.
	EndpointsID = ServiceName  // Service ID for Regions and Endpoints metadata.
)

// New creates a new instance of the CloudTrail client with a config.
//
// Example:
//     // Create a CloudTrail client from just a config.
//     svc := cloudtrail.New(myConfig)
func New(config aws.Config) *CloudTrail {
	var signingName string
	signingRegion := config.Region

	svc := &CloudTrail{
		Client: aws.NewClient(
			config,
			aws.Metadata{
				ServiceName:   ServiceName,
				SigningName:   signingName,
				SigningRegion: signingRegion,
				APIVersion:    "2013-11-01",
				JSONVersion:   "1.1",
				TargetPrefix:  "com.amazonaws.cloudtrail.v20131101.CloudTrail_20131101",
			},
		),
	}

	// Handlers
	svc.Handlers.Sign.PushBackNamed(v4.SignRequestHandler)
	svc.Handlers.Build.PushBackNamed(jsonrpc.BuildHandler)
	svc.Handlers.Unmarshal.PushBackNamed(jsonrpc.UnmarshalHandler)
	svc.Handlers.UnmarshalMeta.PushBackNamed(jsonrpc.UnmarshalMetaHandler)
	svc.Handlers.UnmarshalError.PushBackNamed(jsonrpc.UnmarshalErrorHandler)

	// Run custom client initialization if present
	if initClient != nil {
		initClient(svc)
	}

	return svc
}

// newRequest creates a new request for a CloudTrail operation and runs any
// custom request initialization.
func (c *CloudTrail) newRequest(op *aws.Operation, params, data interface{}) *aws.Request {
	req := c.NewRequest(op, params, data)

	// Run custom request initialization if present
	if initRequest != nil {
		initRequest(c, req)
	}

	return req
}
