// Code generated by private/model/cli/gen-api/main.go. DO NOT EDIT.

package dax

import (
	"github.com/aws/aws-sdk-go-v2/aws"
	"github.com/aws/aws-sdk-go-v2/aws/signer/v4"
	"github.com/aws/aws-sdk-go-v2/private/protocol/jsonrpc"
)

// DAX provides the API operation methods for making requests to
// Amazon DynamoDB Accelerator (DAX). See this package's package overview docs
// for details on the service.
//
// DAX methods are safe to use concurrently. It is not safe to
// modify mutate any of the struct's properties though.
type DAX struct {
	*aws.Client
}

// Used for custom client initialization logic
var initClient func(*DAX)

// Used for custom request initialization logic
var initRequest func(*DAX, *aws.Request)

// Service information constants
const (
	ServiceName = "dax"       // Service endpoint prefix API calls made to.
	EndpointsID = ServiceName // Service ID for Regions and Endpoints metadata.
)

// New creates a new instance of the DAX client with a config.
//
// Example:
//     // Create a DAX client from just a config.
//     svc := dax.New(myConfig)
func New(config aws.Config) *DAX {
	var signingName string
	signingRegion := config.Region

	svc := &DAX{
		Client: aws.NewClient(
			config,
			aws.Metadata{
				ServiceName:   ServiceName,
				SigningName:   signingName,
				SigningRegion: signingRegion,
				APIVersion:    "2017-04-19",
				JSONVersion:   "1.1",
				TargetPrefix:  "AmazonDAXV3",
			},
		),
	}

	// Handlers
	svc.Handlers.Sign.PushBackNamed(v4.SignRequestHandler)
	svc.Handlers.Build.PushBackNamed(jsonrpc.BuildHandler)
	svc.Handlers.Unmarshal.PushBackNamed(jsonrpc.UnmarshalHandler)
	svc.Handlers.UnmarshalMeta.PushBackNamed(jsonrpc.UnmarshalMetaHandler)
	svc.Handlers.UnmarshalError.PushBackNamed(jsonrpc.UnmarshalErrorHandler)

	// Run custom client initialization if present
	if initClient != nil {
		initClient(svc)
	}

	return svc
}

// newRequest creates a new request for a DAX operation and runs any
// custom request initialization.
func (c *DAX) newRequest(op *aws.Operation, params, data interface{}) *aws.Request {
	req := c.NewRequest(op, params, data)

	// Run custom request initialization if present
	if initRequest != nil {
		initRequest(c, req)
	}

	return req
}
