// Code generated by private/model/cli/gen-api/main.go. DO NOT EDIT.

package directoryservice

import (
	"github.com/aws/aws-sdk-go-v2/aws"
	"github.com/aws/aws-sdk-go-v2/aws/signer/v4"
	"github.com/aws/aws-sdk-go-v2/private/protocol/jsonrpc"
)

// DirectoryService provides the API operation methods for making requests to
// AWS Directory Service. See this package's package overview docs
// for details on the service.
//
// DirectoryService methods are safe to use concurrently. It is not safe to
// modify mutate any of the struct's properties though.
type DirectoryService struct {
	*aws.Client
}

// Used for custom client initialization logic
var initClient func(*DirectoryService)

// Used for custom request initialization logic
var initRequest func(*DirectoryService, *aws.Request)

// Service information constants
const (
	ServiceName = "ds"        // Service endpoint prefix API calls made to.
	EndpointsID = ServiceName // Service ID for Regions and Endpoints metadata.
)

// New creates a new instance of the DirectoryService client with a config.
//
// Example:
//     // Create a DirectoryService client from just a config.
//     svc := directoryservice.New(myConfig)
func New(config aws.Config) *DirectoryService {
	var signingName string
	signingRegion := config.Region

	svc := &DirectoryService{
		Client: aws.NewClient(
			config,
			aws.Metadata{
				ServiceName:   ServiceName,
				SigningName:   signingName,
				SigningRegion: signingRegion,
				APIVersion:    "2015-04-16",
				JSONVersion:   "1.1",
				TargetPrefix:  "DirectoryService_20150416",
			},
		),
	}

	// Handlers
	svc.Handlers.Sign.PushBackNamed(v4.SignRequestHandler)
	svc.Handlers.Build.PushBackNamed(jsonrpc.BuildHandler)
	svc.Handlers.Unmarshal.PushBackNamed(jsonrpc.UnmarshalHandler)
	svc.Handlers.UnmarshalMeta.PushBackNamed(jsonrpc.UnmarshalMetaHandler)
	svc.Handlers.UnmarshalError.PushBackNamed(jsonrpc.UnmarshalErrorHandler)

	// Run custom client initialization if present
	if initClient != nil {
		initClient(svc)
	}

	return svc
}

// newRequest creates a new request for a DirectoryService operation and runs any
// custom request initialization.
func (c *DirectoryService) newRequest(op *aws.Operation, params, data interface{}) *aws.Request {
	req := c.NewRequest(op, params, data)

	// Run custom request initialization if present
	if initRequest != nil {
		initRequest(c, req)
	}

	return req
}
