// Code generated by private/model/cli/gen-api/main.go. DO NOT EDIT.

// Package kinesisvideoarchivedmediaiface provides an interface to enable mocking the Amazon Kinesis Video Streams Archived Media service client
// for testing your code.
//
// It is important to note that this interface will have breaking changes
// when the service model is updated and adds new API operations, paginators,
// and waiters.
package kinesisvideoarchivedmediaiface

import (
	"github.com/aws/aws-sdk-go-v2/service/kinesisvideoarchivedmedia"
)

// KinesisVideoArchivedMediaAPI provides an interface to enable mocking the
// kinesisvideoarchivedmedia.KinesisVideoArchivedMedia service client's API operation,
// paginators, and waiters. This make unit testing your code that calls out
// to the SDK's service client's calls easier.
//
// The best way to use this interface is so the SDK's service client's calls
// can be stubbed out for unit testing your code with the SDK without needing
// to inject custom request handlers into the SDK's request pipeline.
//
//    // myFunc uses an SDK service client to make a request to
//    // Amazon Kinesis Video Streams Archived Media.
//    func myFunc(svc kinesisvideoarchivedmediaiface.KinesisVideoArchivedMediaAPI) bool {
//        // Make svc.GetHLSStreamingSessionURL request
//    }
//
//    func main() {
//        cfg, err := external.LoadDefaultAWSConfig()
//        if err != nil {
//            panic("failed to load config, " + err.Error())
//        }
//
//        svc := kinesisvideoarchivedmedia.New(cfg)
//
//        myFunc(svc)
//    }
//
// In your _test.go file:
//
//    // Define a mock struct to be used in your unit tests of myFunc.
//    type mockKinesisVideoArchivedMediaClient struct {
//        kinesisvideoarchivedmediaiface.KinesisVideoArchivedMediaAPI
//    }
//    func (m *mockKinesisVideoArchivedMediaClient) GetHLSStreamingSessionURL(input *kinesisvideoarchivedmedia.GetHLSStreamingSessionURLInput) (*kinesisvideoarchivedmedia.GetHLSStreamingSessionURLOutput, error) {
//        // mock response/functionality
//    }
//
//    func TestMyFunc(t *testing.T) {
//        // Setup Test
//        mockSvc := &mockKinesisVideoArchivedMediaClient{}
//
//        myfunc(mockSvc)
//
//        // Verify myFunc's functionality
//    }
//
// It is important to note that this interface will have breaking changes
// when the service model is updated and adds new API operations, paginators,
// and waiters. Its suggested to use the pattern above for testing, or using
// tooling to generate mocks to satisfy the interfaces.
type KinesisVideoArchivedMediaAPI interface {
	GetHLSStreamingSessionURLRequest(*kinesisvideoarchivedmedia.GetHLSStreamingSessionURLInput) kinesisvideoarchivedmedia.GetHLSStreamingSessionURLRequest

	GetMediaForFragmentListRequest(*kinesisvideoarchivedmedia.GetMediaForFragmentListInput) kinesisvideoarchivedmedia.GetMediaForFragmentListRequest

	ListFragmentsRequest(*kinesisvideoarchivedmedia.ListFragmentsInput) kinesisvideoarchivedmedia.ListFragmentsRequest
}

var _ KinesisVideoArchivedMediaAPI = (*kinesisvideoarchivedmedia.KinesisVideoArchivedMedia)(nil)
