// Code generated by private/model/cli/gen-api/main.go. DO NOT EDIT.

package lexruntimeservice

import (
	"github.com/aws/aws-sdk-go-v2/aws"
	"github.com/aws/aws-sdk-go-v2/aws/signer/v4"
	"github.com/aws/aws-sdk-go-v2/private/protocol/restjson"
)

// LexRuntimeService provides the API operation methods for making requests to
// Amazon Lex Runtime Service. See this package's package overview docs
// for details on the service.
//
// LexRuntimeService methods are safe to use concurrently. It is not safe to
// modify mutate any of the struct's properties though.
type LexRuntimeService struct {
	*aws.Client
}

// Used for custom client initialization logic
var initClient func(*LexRuntimeService)

// Used for custom request initialization logic
var initRequest func(*LexRuntimeService, *aws.Request)

// Service information constants
const (
	ServiceName = "runtime.lex" // Service endpoint prefix API calls made to.
	EndpointsID = ServiceName   // Service ID for Regions and Endpoints metadata.
)

// New creates a new instance of the LexRuntimeService client with a config.
//
// Example:
//     // Create a LexRuntimeService client from just a config.
//     svc := lexruntimeservice.New(myConfig)
func New(config aws.Config) *LexRuntimeService {
	var signingName string
	signingName = "lex"
	signingRegion := config.Region

	svc := &LexRuntimeService{
		Client: aws.NewClient(
			config,
			aws.Metadata{
				ServiceName:   ServiceName,
				SigningName:   signingName,
				SigningRegion: signingRegion,
				APIVersion:    "2016-11-28",
				JSONVersion:   "1.1",
			},
		),
	}

	// Handlers
	svc.Handlers.Sign.PushBackNamed(v4.SignRequestHandler)
	svc.Handlers.Build.PushBackNamed(restjson.BuildHandler)
	svc.Handlers.Unmarshal.PushBackNamed(restjson.UnmarshalHandler)
	svc.Handlers.UnmarshalMeta.PushBackNamed(restjson.UnmarshalMetaHandler)
	svc.Handlers.UnmarshalError.PushBackNamed(restjson.UnmarshalErrorHandler)

	// Run custom client initialization if present
	if initClient != nil {
		initClient(svc)
	}

	return svc
}

// newRequest creates a new request for a LexRuntimeService operation and runs any
// custom request initialization.
func (c *LexRuntimeService) newRequest(op *aws.Operation, params, data interface{}) *aws.Request {
	req := c.NewRequest(op, params, data)

	// Run custom request initialization if present
	if initRequest != nil {
		initRequest(c, req)
	}

	return req
}
