// Code generated by private/model/cli/gen-api/main.go. DO NOT EDIT.

package pinpointemail

import (
	"github.com/aws/aws-sdk-go-v2/aws"
	"github.com/aws/aws-sdk-go-v2/aws/signer/v4"
	"github.com/aws/aws-sdk-go-v2/private/protocol/restjson"
)

// PinpointEmail provides the API operation methods for making requests to
// Amazon Pinpoint Email Service. See this package's package overview docs
// for details on the service.
//
// PinpointEmail methods are safe to use concurrently. It is not safe to
// modify mutate any of the struct's properties though.
type PinpointEmail struct {
	*aws.Client
}

// Used for custom client initialization logic
var initClient func(*PinpointEmail)

// Used for custom request initialization logic
var initRequest func(*PinpointEmail, *aws.Request)

// Service information constants
const (
	ServiceName = "email"     // Service endpoint prefix API calls made to.
	EndpointsID = ServiceName // Service ID for Regions and Endpoints metadata.
)

// New creates a new instance of the PinpointEmail client with a config.
//
// Example:
//     // Create a PinpointEmail client from just a config.
//     svc := pinpointemail.New(myConfig)
func New(config aws.Config) *PinpointEmail {
	var signingName string
	signingName = "ses"
	signingRegion := config.Region

	svc := &PinpointEmail{
		Client: aws.NewClient(
			config,
			aws.Metadata{
				ServiceName:   ServiceName,
				SigningName:   signingName,
				SigningRegion: signingRegion,
				APIVersion:    "2018-07-26",
				JSONVersion:   "1.1",
				TargetPrefix:  "com.amazonaws.services.pinpoint.email",
			},
		),
	}

	// Handlers
	svc.Handlers.Sign.PushBackNamed(v4.SignRequestHandler)
	svc.Handlers.Build.PushBackNamed(restjson.BuildHandler)
	svc.Handlers.Unmarshal.PushBackNamed(restjson.UnmarshalHandler)
	svc.Handlers.UnmarshalMeta.PushBackNamed(restjson.UnmarshalMetaHandler)
	svc.Handlers.UnmarshalError.PushBackNamed(restjson.UnmarshalErrorHandler)

	// Run custom client initialization if present
	if initClient != nil {
		initClient(svc)
	}

	return svc
}

// newRequest creates a new request for a PinpointEmail operation and runs any
// custom request initialization.
func (c *PinpointEmail) newRequest(op *aws.Operation, params, data interface{}) *aws.Request {
	req := c.NewRequest(op, params, data)

	// Run custom request initialization if present
	if initRequest != nil {
		initRequest(c, req)
	}

	return req
}
