// Code generated by private/model/cli/gen-api/main.go. DO NOT EDIT.

package simpledb

import (
	"github.com/aws/aws-sdk-go-v2/aws"
	"github.com/aws/aws-sdk-go-v2/aws/defaults"
	"github.com/aws/aws-sdk-go-v2/aws/signer/v2"
	"github.com/aws/aws-sdk-go-v2/private/protocol/query"
)

// SimpleDB provides the API operation methods for making requests to
// Amazon SimpleDB. See this package's package overview docs
// for details on the service.
//
// SimpleDB methods are safe to use concurrently. It is not safe to
// modify mutate any of the struct's properties though.
type SimpleDB struct {
	*aws.Client
}

// Used for custom client initialization logic
var initClient func(*SimpleDB)

// Used for custom request initialization logic
var initRequest func(*SimpleDB, *aws.Request)

// Service information constants
const (
	ServiceName = "sdb"       // Service endpoint prefix API calls made to.
	EndpointsID = ServiceName // Service ID for Regions and Endpoints metadata.
)

// New creates a new instance of the SimpleDB client with a config.
//
// Example:
//     // Create a SimpleDB client from just a config.
//     svc := simpledb.New(myConfig)
func New(config aws.Config) *SimpleDB {
	var signingName string
	signingRegion := config.Region

	svc := &SimpleDB{
		Client: aws.NewClient(
			config,
			aws.Metadata{
				ServiceName:   ServiceName,
				SigningName:   signingName,
				SigningRegion: signingRegion,
				APIVersion:    "2009-04-15",
			},
		),
	}

	// Handlers
	svc.Handlers.Sign.PushBackNamed(v2.SignRequestHandler)
	svc.Handlers.Sign.PushBackNamed(defaults.BuildContentLengthHandler)
	svc.Handlers.Build.PushBackNamed(query.BuildHandler)
	svc.Handlers.Unmarshal.PushBackNamed(query.UnmarshalHandler)
	svc.Handlers.UnmarshalMeta.PushBackNamed(query.UnmarshalMetaHandler)
	svc.Handlers.UnmarshalError.PushBackNamed(query.UnmarshalErrorHandler)

	// Run custom client initialization if present
	if initClient != nil {
		initClient(svc)
	}

	return svc
}

// newRequest creates a new request for a SimpleDB operation and runs any
// custom request initialization.
func (c *SimpleDB) newRequest(op *aws.Operation, params, data interface{}) *aws.Request {
	req := c.NewRequest(op, params, data)

	// Run custom request initialization if present
	if initRequest != nil {
		initRequest(c, req)
	}

	return req
}
