// Code generated by private/model/cli/gen-api/main.go. DO NOT EDIT.

package swf

import (
	"github.com/aws/aws-sdk-go-v2/aws"
	"github.com/aws/aws-sdk-go-v2/aws/signer/v4"
	"github.com/aws/aws-sdk-go-v2/private/protocol/jsonrpc"
)

// SWF provides the API operation methods for making requests to
// Amazon Simple Workflow Service. See this package's package overview docs
// for details on the service.
//
// SWF methods are safe to use concurrently. It is not safe to
// modify mutate any of the struct's properties though.
type SWF struct {
	*aws.Client
}

// Used for custom client initialization logic
var initClient func(*SWF)

// Used for custom request initialization logic
var initRequest func(*SWF, *aws.Request)

// Service information constants
const (
	ServiceName = "swf"       // Service endpoint prefix API calls made to.
	EndpointsID = ServiceName // Service ID for Regions and Endpoints metadata.
)

// New creates a new instance of the SWF client with a config.
//
// Example:
//     // Create a SWF client from just a config.
//     svc := swf.New(myConfig)
func New(config aws.Config) *SWF {
	var signingName string
	signingRegion := config.Region

	svc := &SWF{
		Client: aws.NewClient(
			config,
			aws.Metadata{
				ServiceName:   ServiceName,
				SigningName:   signingName,
				SigningRegion: signingRegion,
				APIVersion:    "2012-01-25",
				JSONVersion:   "1.0",
				TargetPrefix:  "SimpleWorkflowService",
			},
		),
	}

	// Handlers
	svc.Handlers.Sign.PushBackNamed(v4.SignRequestHandler)
	svc.Handlers.Build.PushBackNamed(jsonrpc.BuildHandler)
	svc.Handlers.Unmarshal.PushBackNamed(jsonrpc.UnmarshalHandler)
	svc.Handlers.UnmarshalMeta.PushBackNamed(jsonrpc.UnmarshalMetaHandler)
	svc.Handlers.UnmarshalError.PushBackNamed(jsonrpc.UnmarshalErrorHandler)

	// Run custom client initialization if present
	if initClient != nil {
		initClient(svc)
	}

	return svc
}

// newRequest creates a new request for a SWF operation and runs any
// custom request initialization.
func (c *SWF) newRequest(op *aws.Operation, params, data interface{}) *aws.Request {
	req := c.NewRequest(op, params, data)

	// Run custom request initialization if present
	if initRequest != nil {
		initRequest(c, req)
	}

	return req
}
